//
//  SLHomeView.m
//  SLAiELTS
//
//  Created by Gusont on 2023/3/10.
//

#import "SLHomeView.h"
#import "SLMessageViewController.h"

@implementation SLHomeView

- (instancetype)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        [self confignMyView];
    }
    return self;
}

- (void)confignMyView
{
    [self.navView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.top.equalTo(self);
        make.height.equalTo(@(kNavBarHeight));
    }];
    [self.mainCollectionView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.bottom.equalTo(self);
        make.top.equalTo(self.navView.mas_bottom).offset(1);
    }];
    NSArray *navs = @[[SLPageModelDetail initWithTitle:@"新增好友" bgImage:@"icon_home_add"],
                      [SLPageModelDetail initWithTitle:@"搜索" bgImage:@"icon_home_search"]];
    [self.navView confignNavViewWith:navs];
    WS(weakSelf);
    self.navView.rightBtnBlock = ^(YMNavBarRightBtnIdx idx) {
        
    };
}

- (void)layoutSubviews
{
    [super layoutSubviews];
}

#pragma mark - UICollectionViewDataSource
- (nonnull __kindof UICollectionViewCell *)collectionView:(nonnull UICollectionView *)collectionView cellForItemAtIndexPath:(nonnull NSIndexPath *)indexPath {
    SLPageViewModel *viewModel = [self.viewModels objectAtIndex:indexPath.section];
    Class cellClass = viewModel.cellClass;
    UICollectionViewCell *cell = [collectionView dequeueReusableCellWithReuseIdentifier:NSStringFromClass(cellClass) forIndexPath:indexPath];
    
    cell.contentView.backgroundColor = self.contentBgColor;

    //通用配置方法，cell各自实现相应的方法
    [cell confignCellWithModel:viewModel.pageModel];
//    [cell confignCellWithModel:viewModel.pageModel];

    cell.contentView.clipsToBounds = YES;
    return cell;
}


- (void)collectionView:(UICollectionView *)collectionView didSelectItemAtIndexPath:(NSIndexPath *)indexPath
{
    SLPageViewModel *viewModel = [self.viewModels objectAtIndex:indexPath.section];
    SLMessageViewController *vc = [SLMessageViewController loadViewControllewWithNib];
    SLFriendsModel *model = [[SLFriendsModel alloc] init];
    model.userId = viewModel.pageModel.chatListModel.userId;
    model.contactsId = viewModel.pageModel.chatListModel.friendId;
    model.name = viewModel.pageModel.chatListModel.dataName;
    model.head = viewModel.pageModel.chatListModel.dataHead;
    vc.friendModel = model;
    [self.viewController navPushViewController:vc animated:YES];
}

- (SLCustNavView *)navView {
    if (!_navView) {
        _navView = [[SLCustNavView alloc] initWithFrame:CGRectZero];
        _navView.infoLabel.text = @"聊天";
        [self addSubview:_navView];
    }
    return _navView;
}

@end
